diff --git a/configure.ac b/configure.ac
index 490e19b..f443ce4 100644
--- a/configure.ac
+++ b/configure.ac
@@ -322,7 +322,7 @@ AC_CONFIG_FILES([Makefile
 		 helper/Makefile
 		 helper/test/Makefile
 		 pkgconfig/libodp-linux.pc
-		 pkgconfig/libodphelper.pc
+		 pkgconfig/libodphelper-linux.pc
 		 scripts/Makefile
 		 ])
 
diff --git a/doc/implementers-guide/implementers-guide.adoc b/doc/implementers-guide/implementers-guide.adoc
index ca434d6..8863004 100644
--- a/doc/implementers-guide/implementers-guide.adoc
+++ b/doc/implementers-guide/implementers-guide.adoc
@@ -121,6 +121,7 @@ of the libraries are libodp-linux and libodp-dpdk respectively. It is
 recommended that other implementations follow the same schema
 (odp-<implementation name>) to make the representation of the ODP
 implementations uniform in a distribution.
+Additionally there is an ODP helper library to abstract OS differences.
 
 == The validation Suite ==
 
diff --git a/example/Makefile.inc b/example/Makefile.inc
index f0bf71d..70ba2c0 100644
--- a/example/Makefile.inc
+++ b/example/Makefile.inc
@@ -1,6 +1,6 @@
 include $(top_srcdir)/platform/@with_platform@/Makefile.inc
 LIB   = $(top_builddir)/lib
-LDADD = $(LIB)/libodp-linux.la $(LIB)/libodphelper.la
+LDADD = $(LIB)/libodp-linux.la $(LIB)/libodphelper-linux.la
 AM_CFLAGS += \
 	-I$(srcdir) \
 	-I$(top_srcdir)/example \
diff --git a/helper/Makefile.am b/helper/Makefile.am
index 4753c48..f9b509f 100644
--- a/helper/Makefile.am
+++ b/helper/Makefile.am
@@ -1,7 +1,7 @@
 include $(top_srcdir)/platform/@with_platform@/Makefile.inc
 
 pkgconfigdir = $(libdir)/pkgconfig
-pkgconfig_DATA = $(top_builddir)/pkgconfig/libodphelper.pc
+pkgconfig_DATA = $(top_builddir)/pkgconfig/libodphelper-linux.pc
 
 LIB   = $(top_builddir)/lib
 AM_CFLAGS  = -I$(srcdir)/include
@@ -27,11 +27,11 @@ noinst_HEADERS = \
 		 $(srcdir)/odph_lineartable.h \
 		 $(srcdir)/odph_list_internal.h
 
-__LIB__libodphelper_la_SOURCES = \
+__LIB__libodphelper_linux_la_SOURCES = \
 					eth.c \
 					ip.c \
 					linux.c \
 					hashtable.c \
 					lineartable.c
 
-lib_LTLIBRARIES = $(LIB)/libodphelper.la
+lib_LTLIBRARIES = $(LIB)/libodphelper-linux.la
diff --git a/helper/test/Makefile.am b/helper/test/Makefile.am
index 0c374e6..7f0b67d 100644
--- a/helper/test/Makefile.am
+++ b/helper/test/Makefile.am
@@ -26,8 +26,8 @@ bin_PROGRAMS = $(EXECUTABLES) $(COMPILE_ONLY)
 
 dist_chksum_SOURCES = chksum.c
 dist_thread_SOURCES = thread.c
-thread_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
+thread_LDADD = $(LIB)/libodphelper-linux.la $(LIB)/libodp-linux.la
 dist_process_SOURCES = process.c
 dist_parse_SOURCES = parse.c
-process_LDADD = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
+process_LDADD = $(LIB)/libodphelper-linux.la $(LIB)/libodp-linux.la
 dist_table_SOURCES = table.c
diff --git a/pkg/debian/libodphelper-dev.install b/pkg/debian/libodphelper-dev.install
deleted file mode 100644
index b973af4..0000000
--- a/pkg/debian/libodphelper-dev.install
+++ /dev/null
@@ -1,4 +0,0 @@
-usr/include/*
-usr/lib/*/lib*.so
-usr/lib/*/lib*.a
-usr/lib/*/pkgconfig/*
diff --git a/pkg/debian/libodphelper-dev.dirs b/pkg/debian/libodphelper-linux-dev.dirs
similarity index 100%
rename from pkg/debian/libodphelper-dev.dirs
rename to pkg/debian/libodphelper-linux-dev.dirs
diff --git a/pkg/debian/libodphelper-linux-dev.install b/pkg/debian/libodphelper-linux-dev.install
new file mode 100644
index 0000000..7d9a2a8
--- /dev/null
+++ b/pkg/debian/libodphelper-linux-dev.install
@@ -0,0 +1,4 @@
+usr/include/odp/helper/*
+usr/lib/*/libodphelper-linux.so
+usr/lib/*/libodphelper-linux.a
+usr/lib/*/pkgconfig/libodphelper-linux*
diff --git a/pkg/debian/libodphelper.dirs b/pkg/debian/libodphelper-linux.dirs
similarity index 100%
rename from pkg/debian/libodphelper.dirs
rename to pkg/debian/libodphelper-linux.dirs
diff --git a/pkg/debian/libodphelper-linux.install b/pkg/debian/libodphelper-linux.install
new file mode 100644
index 0000000..896feed
--- /dev/null
+++ b/pkg/debian/libodphelper-linux.install
@@ -0,0 +1 @@
+usr/lib/*/libodphelper-linux.so.*
diff --git a/pkg/debian/libodphelper.install b/pkg/debian/libodphelper.install
deleted file mode 100644
index 3ddde58..0000000
--- a/pkg/debian/libodphelper.install
+++ /dev/null
@@ -1 +0,0 @@
-usr/lib/*/lib*.so.*
diff --git a/pkgconfig/libodphelper.pc.in b/pkgconfig/libodphelper-linux.pc.in
similarity index 76%
rename from pkgconfig/libodphelper.pc.in
rename to pkgconfig/libodphelper-linux.pc.in
index 2993d71..71c7d5d 100644
--- a/pkgconfig/libodphelper.pc.in
+++ b/pkgconfig/libodphelper-linux.pc.in
@@ -3,9 +3,9 @@ exec_prefix=@exec_prefix@
 libdir=@libdir@
 includedir=@includedir@
 
-Name: libodphelper
+Name: libodphelper-linux
 Description: Helper for the ODP packet processing engine
 Version: @VERSION@
-Libs: -L${libdir} -lodphelper
+Libs: -L${libdir} -lodphelper-linux
 Libs.private:
 Cflags: -I${includedir}
diff --git a/platform/linux-generic/test/Makefile.inc b/platform/linux-generic/test/Makefile.inc
index 13707a7..527d8cb 100644
--- a/platform/linux-generic/test/Makefile.inc
+++ b/platform/linux-generic/test/Makefile.inc
@@ -6,7 +6,7 @@ AM_LDFLAGS += -static
 
 LIBCUNIT_COMMON = $(top_builddir)/test/validation/common/libcunit_common.la
 LIB   = $(top_builddir)/lib
-LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
+LIBODP = $(LIB)/libodphelper-linux.la $(LIB)/libodp-linux.la
 
 INCCUNIT_COMMON = -I$(top_srcdir)/test/validation/common
 INCODP = -I$(top_srcdir)/test \
diff --git a/test/Makefile.inc b/test/Makefile.inc
index b3cb4a5..c4399cb 100644
--- a/test/Makefile.inc
+++ b/test/Makefile.inc
@@ -4,7 +4,7 @@ LIB   = $(top_builddir)/lib
 #in the following line, the libs using the symbols should come before
 #the libs containing them! The includer is given a chance to add things
 #before libodp by setting PRE_LDADD before the inclusion.
-LDADD = $(PRE_LDADD) $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
+LDADD = $(PRE_LDADD) $(LIB)/libodphelper-linux.la $(LIB)/libodp-linux.la
 
 INCFLAGS = -I$(top_srcdir)/test \
 	-I$(top_srcdir)/platform/@with_platform@/include \
diff --git a/test/validation/Makefile.inc b/test/validation/Makefile.inc
index 1535926..9f36f9d 100644
--- a/test/validation/Makefile.inc
+++ b/test/validation/Makefile.inc
@@ -13,4 +13,4 @@ AM_LDFLAGS += -static
 LIBCUNIT_COMMON = $(COMMON_DIR)/libcunit_common.la
 LIBCPUMASK_COMMON = $(COMMON_DIR)/libcpumask_common.la
 LIBTHRMASK_COMMON = $(COMMON_DIR)/libthrmask_common.la
-LIBODP = $(LIB)/libodphelper.la $(LIB)/libodp-linux.la
+LIBODP = $(LIB)/libodphelper-linux.la $(LIB)/libodp-linux.la