diff --git a/configure.ac b/configure.ac
index 4016176b..ac36ee89 100644
--- a/configure.ac
+++ b/configure.ac
@@ -19,7 +19,7 @@ AC_SUBST(ODP_VERSION_API_MINOR)
 AC_CONFIG_FILES([include/odp/api/spec/version.h
                  include/odp/api/spec/deprecated.h])
 
-AM_INIT_AUTOMAKE([1.9 tar-pax subdir-objects foreign])
+AM_INIT_AUTOMAKE([1.9 tar-pax subdir-objects foreign nostdinc])
 AC_CONFIG_SRCDIR([include/odp/api/spec/init.h])
 AM_CONFIG_HEADER([include/config.h])
 
diff --git a/platform/linux-generic/arch/x86/cpu_flags.c b/platform/linux-generic/arch/x86/cpu_flags.c
index 690a084e..e46c4ffb 100644
--- a/platform/linux-generic/arch/x86/cpu_flags.c
+++ b/platform/linux-generic/arch/x86/cpu_flags.c
@@ -39,7 +39,7 @@
 
 #include "config.h"
 
-#include <arch/x86/cpu_flags.h>
+#include <cpu_flags.h>
 #include <odp_debug_internal.h>
 #include <odp_time_internal.h>
 #include <stdio.h>
diff --git a/platform/linux-generic/arch/x86/odp_sysinfo_parse.c b/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
index f4a90ecd..f7918d40 100644
--- a/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
+++ b/platform/linux-generic/arch/x86/odp_sysinfo_parse.c
@@ -7,7 +7,7 @@
 #include "config.h"
 
 #include <odp_internal.h>
-#include <arch/x86/cpu_flags.h>
+#include <cpu_flags.h>
 #include <string.h>
 
 int cpuinfo_parser(FILE *file, system_info_t *sysinfo)
diff --git a/test/common_plat/common/odp_cunit_common.c b/test/common_plat/common/odp_cunit_common.c
index a83c3026..08bf1f26 100644
--- a/test/common_plat/common/odp_cunit_common.c
+++ b/test/common_plat/common/odp_cunit_common.c
@@ -8,7 +8,7 @@
 
 #include <string.h>
 #include <odp_api.h>
-#include <odp_cunit_common.h>
+#include "odp_cunit_common.h"
 #include <odp/helper/odph_api.h>
 /* Globals */
 static odph_odpthread_t thread_tbl[MAX_WORKERS];
diff --git a/test/common_plat/performance/odp_pktio_ordered.c b/test/common_plat/performance/odp_pktio_ordered.c
index b08fa852..e772411a 100644
--- a/test/common_plat/performance/odp_pktio_ordered.c
+++ b/test/common_plat/performance/odp_pktio_ordered.c
@@ -24,7 +24,7 @@
 #include <inttypes.h>
 
 #include <test_debug.h>
-#include <dummy_crc.h>
+#include "dummy_crc.h"
 
 #include <odp_api.h>
 #include <odp/helper/threads.h>
diff --git a/test/common_plat/validation/api/Makefile.inc b/test/common_plat/validation/api/Makefile.inc
index 177d2ac3..767526ed 100644
--- a/test/common_plat/validation/api/Makefile.inc
+++ b/test/common_plat/validation/api/Makefile.inc
@@ -2,11 +2,6 @@ include $(top_srcdir)/test/Makefile.inc
 
 COMMON_DIR = $(top_builddir)/test/common_plat/common
 
-#the following option ensure that option '-I.' is not passed to gcc,
-#therefore distinguishing between '#include "X"' and '#include <X>'.
-#It allows common filenames (such as 'errno.h') to be used locally.
-AUTOMAKE_OPTIONS = nostdinc
-
 AM_CFLAGS += -I$(top_srcdir)/test/common_plat/common
 AM_LDFLAGS += -static
 AM_LDFLAGS += $(DPDK_PMDS)
diff --git a/test/linux-generic/ring/Makefile.am b/test/linux-generic/ring/Makefile.am
index c0865848..14f60b85 100644
--- a/test/linux-generic/ring/Makefile.am
+++ b/test/linux-generic/ring/Makefile.am
@@ -7,6 +7,7 @@ libtestring_la_CFLAGS = $(AM_CFLAGS) $(INCCUNIT_COMMON) $(INCODP)
 test_PROGRAMS = ring_main$(EXEEXT)
 dist_ring_main_SOURCES = ring_main.c
 
+ring_main_CFLAGS = $(AM_CFLAGS) -I$(top_builddir)/include
 ring_main_LDFLAGS = $(AM_LDFLAGS)
 ring_main_LDADD = libtestring.la $(LIBCUNIT_COMMON) $(LIBODP)
 
diff --git a/test/linux-generic/validation/api/shmem/Makefile.am b/test/linux-generic/validation/api/shmem/Makefile.am
index b0ae6273..e330d633 100644
--- a/test/linux-generic/validation/api/shmem/Makefile.am
+++ b/test/linux-generic/validation/api/shmem/Makefile.am
@@ -7,6 +7,7 @@ test_extradir = $(testdir)
 
 #shmem_linux is stand alone, pure linux (no ODP):
 dist_shmem_linux_SOURCES = shmem_linux.c
+shmem_linux_CFLAGS = $(AM_CFLAGS) -I$(top_builddir)/include
 shmem_linux_LDFLAGS = $(AM_LDFLAGS) -lrt
 
 #shmem_odp1 and shmem_odp2 are the 2 ODP processes: